Option Strict On
Imports ICSharpCode.SharpZipLib
Imports System.Drawing

Public Class NetCBZLib

    Protected l_FileName As String
    Protected l_ZipFile As Zip.ZipFile
    Protected l_ZipFileEntries As ArrayList
    Public Sub New(ByVal file As String)
        l_FileName = file
        LoadFileInfo()
    End Sub

    Protected Sub LoadFileInfo()

        If Not isZip(l_FileName) Then
            'UnrarApp.ConvertCBRToCBZ(l_FileName, System.IO.Path.GetFullPath(l_FileName))
            'l_FileName = System.IO.Path.GetFullPath(l_FileName) + "\" + System.IO.Path.GetFileNameWithoutExtension(l_FileName) + ".cbz"
            LoadRarFileInfo()
            Exit Sub
        End If

        l_ZipFile = New Zip.ZipFile(l_FileName)
        l_pageCount = 0
        l_ZipFileEntries = New ArrayList
        For Each x As Zip.ZipEntry In l_ZipFile
            Dim __filenameInfo() As String = Split(x.Name, "."c)
            If __filenameInfo.Length > 1 AndAlso ("gif jpg").IndexOf(__filenameInfo(__filenameInfo.Length - 1).ToLower()) > -1 Then
                l_pageCount += 1
                l_ZipFileEntries.Add(x)
            End If
        Next
        Dim sorter As New ZipEntrySorter
        l_ZipFileEntries.Sort(sorter)
    End Sub

    Protected Sub LoadRarFileInfo()
        Dim __rar As Decompressor = Nothing
        Try
            __rar = New Decompressor(l_FileName)
            l_pageCount = 0
            'Dim __list() As String = __rar.RARFiles
            l_ZipFileEntries = New ArrayList
            For Each x As Decompressor.RAREntry In __rar.RARFiles

                Dim __filenameInfo() As String = Split(x.FileName, "."c)
                If __filenameInfo.Length > 1 AndAlso ("gif jpg").IndexOf(__filenameInfo(__filenameInfo.Length - 1).ToLower()) > -1 Then
                    l_pageCount += 1
                    l_ZipFileEntries.Add(x)
                End If
            Next
            'Dim sorter As New ZipEntrySorter
            'l_ZipFileEntries.Sort(sorter)
        Catch ex As Exception
            MsgBox(ex.ToString())
        Finally
            'If __rar IsNot Nothing Then __rar.Close()

            __rar = Nothing
        End Try
    End Sub

    Protected l_IOStream As System.IO.FileStream
    Protected Shared l_maxWidth As Integer = 600
    Public Shared Property maxWidth() As Integer
        Get
            Return l_maxWidth
        End Get
        Set(ByVal Value As Integer)
            l_maxWidth = Value
        End Set
    End Property

    Protected Shared l_maxHeight As Integer = 960
    Public Shared Property maxHeight() As Integer
        Get
            Return l_maxHeight
        End Get
        Set(ByVal Value As Integer)
            l_maxHeight = Value
        End Set
    End Property

    Protected l_pageCount As Integer = 0
    Public ReadOnly Property pageCount() As Integer
        Get
            Return l_pageCount
        End Get
    End Property

    Protected l_page As Integer = 1
    Public Property Page() As Integer
        Get
            Return l_page
        End Get
        Set(ByVal Value As Integer)
            If Value > 0 Then
                l_page = Value
            End If
        End Set
    End Property

    Protected l_quality As Long = 100
    Public Property JpegQuality() As Long
        Get
            Return l_quality
        End Get
        Set(ByVal value As Long)
            l_quality = value
        End Set
    End Property

    Public Function currentPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
        Return getPicture(width, height)
    End Function

    Public Function NextPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
        If l_page = l_pageCount Then l_page = 0
        l_page += 1
        Return getPicture(width, height)
    End Function

    Public Function PrevPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
        If l_page = 1 Then l_page = l_pageCount + 1
        l_page = l_page - 1
        Return getPicture(width, height)

    End Function

    Protected Function getPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
        'Dim __ZipFile As New Zip.ZipFile("..\slsh257.cbz")
        'Dim __ZipEntry As Zip.ZipEntry = __ZipFile.EntryByIndex(0)
        Dim __stream As IO.Stream
        Dim m_img As System.Drawing.Bitmap = Nothing
        Dim m_rtn As System.Drawing.Bitmap = Nothing
        Dim g As Graphics = Nothing
        Try
            If Right(Trim(l_FileName), 3).ToLower() = "cbr" Then Return getRarPicture(width, height)
            'If Right(Trim(l_FileName), 3).ToLower() = "cbt" Then Return GetCbtPicture(width, height)

            __stream = l_ZipFile.GetInputStream(DirectCast(l_ZipFileEntries(l_page - 1), Zip.ZipEntry))

            m_img = New System.Drawing.Bitmap(__stream)
            __stream.Close()
            __stream = Nothing
            Dim _width As Integer = CInt(IIf((width <= 0 AndAlso height <= 0) OrElse (width > 0 AndAlso height > 0), m_img.Width, IIf(width > 0, width, m_img.Width * (height / m_img.Height))))
            Dim _height As Integer = CInt(IIf((width <= 0 AndAlso height <= 0) OrElse (width > 0 AndAlso height > 0), m_img.Height, IIf(height > 0, height, m_img.Height * (width / m_img.Width))))

            If _height > l_maxHeight Then
                _width = width
                _height = CInt(m_img.Height * (_width / m_img.Width))
                If _height > l_maxHeight Then
                    _height = height
                    _width = CInt(m_img.Width * (_height / m_img.Height))
                End If

            Else
                If _width > l_maxWidth Then
                    _height = _height
                    _width = CInt(m_img.Width * (_height / m_img.Height))

                    If _width > l_maxWidth Then
                        _width = width
                        _height = CInt(m_img.Height * (_width / m_img.Width))
                    End If
                End If
            End If

            If height > _height Then
                _width = l_maxWidth
                _height = CInt(m_img.Height * (_width / m_img.Width))
                If height > _height Then
                    _height = l_maxHeight
                    _width = CInt(m_img.Width * (_height / m_img.Height))
                End If
            Else
                If width > _width Then
                    _height = l_maxHeight
                    _width = CInt(m_img.Width * (_height / m_img.Height))
                    If width > _width Then

                        _width = l_maxWidth
                        _height = CInt(m_img.Height * (_width / m_img.Width))
                    End If
                End If
            End If

            m_rtn = New Bitmap(_width, _height)
            g = Graphics.FromImage(m_rtn)
            g.DrawImage(m_img, 0, 0, _width, _height)
            g.Dispose()
            g = Nothing
            Return m_rtn

        Catch ex As Exception
        Finally
            If Not m_img Is Nothing Then
                m_img.Dispose()
                m_img = Nothing
            End If
        End Try
        Return Nothing
    End Function


    Protected Function getRarPicture() As System.Drawing.Bitmap
        Return getRarPicture(0, 0)
    End Function

    Protected Function getRarPicture(ByVal width As Integer) As System.Drawing.Bitmap
        Return getRarPicture(width, 0)
    End Function

    Protected Function getRarPicture(ByVal width As Integer, ByVal height As Integer) As System.Drawing.Bitmap
        Dim __rar As Decompressor = Nothing
        Try
            Dim bmp As System.Drawing.Bitmap = Nothing
            Dim rtn As System.Drawing.Bitmap = Nothing
            Dim filename As String = ""
            Dim dest As String = ""
            Try
                __rar = New Decompressor(l_FileName)
                '__rar.Open()
                filename = DirectCast(l_ZipFileEntries(l_page - 1), String)

                Dim __path() As String = filename.Split("\"c)
                Dim __dest As String

                If __path.Length > 0 Then
                    __dest = __path(__path.Length - 1)
                Else
                    __dest = filename
                End If

                If __rar.UnPack(filename, __dest) AndAlso System.IO.File.Exists(filename) Then
                    bmp = New System.Drawing.Bitmap(filename)
                Else
                    bmp = New System.Drawing.Bitmap(CInt(IIf(width = 0, 640, width)), CInt(IIf(height = 0, 480, height)), System.Drawing.Imaging.PixelFormat.DontCare)
                End If

                Dim _width As Integer
                Dim _height As Integer

                If (width <= 0) Then
                    _width = bmp.Width
                    _height = bmp.Height
                Else
                    _width = width
                    _height = CInt(bmp.Height * (width / bmp.Width))
                End If

                If height > 0 AndAlso _height < height Then
                    _height = height
                    _width = CInt(bmp.Width * (height / bmp.Height))
                End If

                rtn = New Bitmap(_width, _height)
                Dim __g As Graphics = Graphics.FromImage(rtn)
                __g.DrawImage(bmp, 0, 0, _width, _height)
                __g.Dispose()
                __g = Nothing

                Return rtn
            Catch ex As Exception
                'MsgBox("the following error ocurred while decompressing:" + vbCrLf + ex.ToString())
            Finally
                If Not bmp Is Nothing Then
                    bmp.Dispose()
                    bmp = Nothing
                End If
                'If __rar IsNot Nothing Then __rar.Close()
                __rar = Nothing
                Dim __path() As String = filename.Split("\"c)
                Try
                    Microsoft.VisualBasic.Kill(filename)
                Catch

                End Try
                If __path.Length - 2 >= 0 Then
                    __path(__path.Length - 1) = ""
                    Dim __length As Integer = __path.Length - 2
                    For x As Integer = __length To 0 Step -1

                        Dim __SubDir As String = String.Join("\", __path)
                        Try
                            Microsoft.VisualBasic.RmDir(__SubDir)
                        Catch
                        End Try
                    Next
                End If

            End Try
            Return Nothing
        Catch
        End Try
    End Function

    ''' <summary>
    ''' Rescales a CBZ or CBR files images so that it is a little easier
    ''' to view on the PocketPC.  It also resaves the file as a CBZ (PKZip) which
    ''' is the only format that the PocketPC viewer can read.
    ''' </summary>
    ''' <param name="FileName"></param>
    ''' <param name="width"></param>
    ''' <param name="height"></param>
    ''' <remarks></remarks>
    Public Sub ScaleAll(ByVal FileName As String, Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0)
        Dim ncode() As System.Drawing.Imaging.ImageCodecInfo = System.Drawing.Imaging.ImageCodecInfo.GetImageEncoders()
        Dim encoder As System.Drawing.Imaging.ImageCodecInfo = Nothing

        For x As Integer = 0 To ncode.Length - 1
            With ncode(x)
                If .FormatDescription.ToLower() = "jpeg" Then
                    encoder = ncode(x)
                    Exit For
                End If
            End With

        Next

        Dim __params As System.Drawing.Imaging.EncoderParameters = New System.Drawing.Imaging.EncoderParameters(2)
        __params.Param(0) = New System.Drawing.Imaging.EncoderParameter(System.Drawing.Imaging.Encoder.Quality, l_quality)
        __params.Param(1) = New System.Drawing.Imaging.EncoderParameter(System.Drawing.Imaging.Encoder.ColorDepth, 256L)

        If width = 0 AndAlso height = 0 Then Exit Sub

        If (Not isZip(Me.l_FileName)) Then
            Me.l_FileName = ConvertCBR2CBZ(Me.l_FileName)
            LoadFileInfo()
        End If

        Dim __out As New System.IO.FileStream(Replace(FileName.ToLower(), ".cbr", ".cbz"), IO.FileMode.Create)
        Dim _newzip As New Zip.ZipOutputStream(__out)
        For x As Integer = 1 To l_pageCount
            l_page = x
            Dim __bmp As Bitmap = getPicture(width, height)
            Dim _ze As Zip.ZipEntry
            If TypeOf (l_ZipFileEntries(x - 1)) Is Zip.ZipEntry Then
                _ze = New Zip.ZipEntry(DirectCast(l_ZipFileEntries(x - 1), Zip.ZipEntry).Name)
            Else
                Dim __fn() As String = DirectCast(l_ZipFileEntries(x - 1), String).Split("\"c)
                If __fn.Length > 0 Then
                    _ze = New Zip.ZipEntry(__fn(__fn.Length - 1))
                Else
                    _ze = New Zip.ZipEntry(__fn(0))
                End If
            End If

            If Not __bmp Is Nothing Then
                _newzip.PutNextEntry(_ze)
                _newzip.SetLevel(9)
                __bmp.Save(_newzip, encoder, __params)
                __bmp.Dispose()
                __bmp = Nothing
            End If

        Next
        _newzip.Finish()
        _newzip.Close()
        __out.Close()
    End Sub

    Public Function ConvertCBR2CBZ(ByVal FileName As String) As String
        Try
            If (System.IO.Path.GetExtension(FileName) = ".cbz") Then
                System.IO.File.Move(FileName, System.IO.Path.GetFileNameWithoutExtension(FileName) + ".cbr")
                FileName = System.IO.Path.GetFileNameWithoutExtension(FileName) + ".cbr"
            End If

            Dim tempDir As String = System.IO.Path.GetDirectoryName(Application.ExecutablePath) + "\" + System.IO.Path.GetFileNameWithoutExtension(FileName)
            System.IO.Directory.CreateDirectory(tempDir)
            Dim dc As New Decompressor(FileName)

            'dc.ExtractToDirectory(tempDir)
            Try
                dc.UnPackAll(tempDir)
            Catch ex As Exception

            End Try


            Dim fz As New Zip.FastZip
            Dim _CurrentFile As String = System.IO.Path.GetFileName(FileName)

            fz.CreateZip(FileName.ToLower().Replace(".cbr", ".cbz"), tempDir, True, Nothing)
            ConvertCBR2CBZ = FileName.ToLower().Replace(".cbr", ".cbz")
            Dim di As System.IO.DirectoryInfo = New System.IO.DirectoryInfo(tempDir)
            di.Delete(True)
        Catch ex As Exception
                MsgBox(ex.ToString())
            Finally
            End Try

    End Function

    ''' <summary>
    ''' Creates a CBZ file from a directory containing pictures.  Ok the truth is that
    ''' it simply zips the directory's files and changes the extension to CBZ.  If 
    ''' CompactFile parameter contains a string that is longer than 4 characters then 
    ''' ScaleAll will be called to create a CBZ viewable on a PocketPC.
    ''' </summary>
    ''' <param name="DirPath"></param>
    ''' <param name="NewFile"></param>
    ''' <param name="CompactFile"></param>
    ''' <remarks></remarks>
    Public Shared Sub CreateFromDirectoryOfPix(ByVal DirPath As System.IO.DirectoryInfo, ByVal NewFile As String, ByVal CompactFile As String)
        Dim zp As New ICSharpCode.SharpZipLib.Zip.FastZip
        zp.CreateZip(NewFile, DirPath.FullName, False, "")

        If CompactFile.Length > 0 Then
            Dim libCBZ As New NetCBZLib(NewFile)
            libCBZ.ScaleAll(CompactFile)
        End If
    End Sub

    ''' <summary>
    ''' Determines whether the specified file name is zip.
    ''' </summary>
    ''' <param name="FileName">Name of the file.</param>
    ''' <returns>
    ''' <c>true</c> if the specified file name is zip; otherwise, <c>false</c>.
    ''' </returns>
    Protected Function isZip(ByVal FileName As String) As Boolean
        'Dim fs As System.IO.FileStream = Nothing
        isZip = False
        Try
            Dim ZipTest As New Zip.ZipFile(FileName)
            isZip = ZipTest.TestArchive(False)
            'If (System.IO.File.Exists(FileName)) Then
            '    fs = System.IO.File.OpenRead(FileName)
            '    Dim buffer(1) As Byte
            '    fs.Read(buffer, 0, 2)
            '    Return ((New String(System.Text.ASCIIEncoding.GetEncoding(0).GetChars(buffer))).ToLower() = "pk")
            'End If
        Catch ex As Exception
        Finally
            'If Not fs Is Nothing Then fs.Close()
            'fs = Nothing
        End Try
    End Function

End Class

Public Class ZipEntrySorter
    Implements IComparer

    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Dim z As New System.Collections.Comparer(Application.CurrentCulture)
        Try

            If Not TypeOf (x) Is Zip.ZipEntry AndAlso Not TypeOf (y) Is Zip.ZipEntry AndAlso Not TypeOf (x) Is String AndAlso Not TypeOf (y) Is String Then

                Return z.Compare(x, y)

            End If
            If TypeOf (x) Is Zip.ZipEntry Then
                Dim obj1 As Zip.ZipEntry = DirectCast(x, Zip.ZipEntry)
                Dim obj2 As Zip.ZipEntry = DirectCast(y, Zip.ZipEntry)
                Return z.Compare(obj1.Name, obj2.Name)
            Else
                Dim obj1 As String = DirectCast(x, String)
                Dim obj2 As String = DirectCast(y, String)
                Return z.Compare(obj1, obj2)

            End If
        Finally
            z = Nothing
        End Try
    End Function
End Class