using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PocketNetCBZ
{
    public partial class Form1 : Form
    {
        protected NetCFCBZLib cbzLib;
        protected System.Drawing.Bitmap Img;
        protected System.Drawing.Rectangle ImgRec;
        private int lastX = 0;
        private int lastY = 0;
        protected const int MOVEINDEX = 100;
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Panel1_MouseDown(object sender, MouseEventArgs e)
        {
            lastX = e.X;
            lastY = e.Y;

        }

        private void Panel1_Paint(object sender, PaintEventArgs e)
        {
            if (Img == null)
            {
                return;
            }
            e.Graphics.DrawImage(Img, new Rectangle(0, 0, Panel1.Width, Panel1.Height), new Rectangle(hsb1.Value, vsb1.Value, Panel1.Width, Panel1.Height), GraphicsUnit.Pixel);


        }

        private void Panel1_MouseUp(object sender, MouseEventArgs e)
        {
            int xDiff = 0;
            int yDiff = 0;

            xDiff = lastX - e.X;
            yDiff = lastY - e.Y;

            lastX = 0;
            lastY = 0;

            hsb1.Value += xDiff;
            vsb1.Value += yDiff;

            ImgRec = new Rectangle(hsb1.Value, vsb1.Value, Panel1.Width, Panel1.Height);
            drawImage();

        }
        
        private void vsb1_ValueChanged(object sender, EventArgs e)
        {
            NewPosition(hsb1.Value, vsb1.Value);
        }

        private void hsb1_ValueChanged(object sender, EventArgs e)
        {
            NewPosition(hsb1.Value, vsb1.Value);
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.OpenFileDialog OFD = new System.Windows.Forms.OpenFileDialog();
		OFD.InitialDirectory = "";
		OFD.FileName = "";
		OFD.Filter = "(*.CBZ)|*.cbz|All Files|*.*";
		if (OFD.ShowDialog() == System.Windows.Forms.DialogResult.Cancel || OFD.FileName.Length <= 0)
		{
			return;
		}
		cbzLib = new NetCFCBZLib(OFD.FileName);
		OFD = null;

		Img = cbzLib.currentPicture();

		ImgRec = new System.Drawing.Rectangle(0, 0, Panel1.Width-1, Panel1.Height-1);
        resetScrollbars();
        }

        private void PrevPage_Click(object sender, EventArgs e)
        {
            Img.Dispose();
            Img = null;
            Img = cbzLib.PrevPicture();
            resetScrollbars();
        }

        private void mnuZoomOut_Click(object sender, EventArgs e)
        {
            if (Img == null)
            {
                return;
            }
            Bitmap tempImg = new Bitmap(System.Convert.ToInt32(Img.Width / 2), System.Convert.ToInt32(Img.Height / 2)); //Img
            Graphics g = Graphics.FromImage(tempImg);
            g.DrawImage(Img, new Rectangle(0, 0, tempImg.Width, tempImg.Height), new Rectangle(0, 0, Img.Width, Img.Height), System.Drawing.GraphicsUnit.Pixel);

            Img.Dispose();
            Img = null;
            Img = new Bitmap(tempImg.Width, tempImg.Height);
            mnuZoomIn.Enabled = true;
            mnuZoomOut.Enabled = false;

            g = Graphics.FromImage(Img);
            g.DrawImage(tempImg, new Rectangle(0, 0, Img.Width, Img.Height), new Rectangle(0, 0, tempImg.Width, tempImg.Height), System.Drawing.GraphicsUnit.Pixel);
            //ImgRec = New System.Drawing.Rectangle(0, 0, Panel1.Width, Panel1.Height)
            resetScrollbars();
            Panel1.Invalidate();
            g = null;
            tempImg.Dispose();
            tempImg = null;

        }

        private void mnuZoomIn_Click(object sender, EventArgs e)
        {
            if (Img == null)
            {
                return;
            }
            Bitmap tempImg = new Bitmap(Img.Width * 2, Img.Height * 2); //Img
            Graphics g = Graphics.FromImage(tempImg);
            g.DrawImage(Img, new Rectangle(0, 0, tempImg.Width, tempImg.Height), new Rectangle(0, 0, Img.Width, Img.Height), System.Drawing.GraphicsUnit.Pixel);

            Img.Dispose();
            Img = null;
            Img = new Bitmap(tempImg.Width, tempImg.Height);
            mnuZoomOut.Enabled = true;
            mnuZoomIn.Enabled = false;

            g = Graphics.FromImage(Img);
            g.DrawImage(tempImg, new Rectangle(0, 0, Img.Width, Img.Height), new Rectangle(0, 0, tempImg.Width, tempImg.Height), System.Drawing.GraphicsUnit.Pixel);
            //ImgRec = New System.Drawing.Rectangle(0, 0, Panel1.Width, Panel1.Height)
            resetScrollbars();
            Panel1.Invalidate();
            g = null;
            tempImg.Dispose();
            tempImg = null;
        }

        private void NextPage_Click(object sender, EventArgs e)
        {
            Img.Dispose();
            Img = null;
            Img = cbzLib.NextPicture();
            resetScrollbars();
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        protected void drawImage()
        {
            Panel1.Refresh();
        }

        private void NewPosition(int newX, int newY)
        {
            ImgRec = new Rectangle(newX, newY, Panel1.Width, Panel1.Height);

            hsb1.Value = newX;
            vsb1.Value = newY;
            drawImage();
        }

        protected void resetScrollbars()
        {
            //resetScrollbars()
            vsb1.Minimum = 0;
            if (Img.Height > Panel1.Height)
            {
                vsb1.Maximum = Img.Height - Panel1.Height + 1;
            }
            else
            {
                vsb1.Maximum = 0;
            }
            vsb1.Value = 0;

            hsb1.Minimum = 0;
            if (Img.Width > Panel1.Width)
            {
                hsb1.Maximum = Img.Width - Panel1.Width + 1;
            }
            else
            {
                hsb1.Maximum = 0;
            }
            hsb1.Value = 0;

            ImgRec = new Rectangle(0, 0, Panel1.Width, Panel1.Height);

            drawImage();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            int lX = hsb1.Value;
            int lY = vsb1.Value;

            if (e.KeyCode == System.Windows.Forms.Keys.Up)
            {
                //Rocker Up
                //Up
                if (lY - MOVEINDEX > 0)
                {
                    lY = lY - MOVEINDEX;
                }
                else
                {
                    lY = 0;
                }


            }
            if (e.KeyCode == System.Windows.Forms.Keys.Down)
            {
                //Rocker Down
                //Down
                if (lY + MOVEINDEX < Img.Height - Panel1.Height + 50)
                {
                    lY = lY + MOVEINDEX;
                }
                else
                {
                    lY = vsb1.Maximum; // Img.Width - Panel1.Width + 50;
                }
            }

            if (e.KeyCode == System.Windows.Forms.Keys.Left)
            {
                //Left
                if (lX - MOVEINDEX > 0)
                {
                    lX = lX - MOVEINDEX;
                }
                else
                {
                    lX = 0;
                }

            }

            if (e.KeyCode == System.Windows.Forms.Keys.Right)
            {
                //Right
                if (lX + MOVEINDEX < Img.Width - Panel1.Width + 10)
                {
                    lX = lX + MOVEINDEX;
                }
                else
                {
                    lX = hsb1.Maximum; //Img.Width - Panel1.Width + 50;
                }

            }

            if (e.KeyCode == System.Windows.Forms.Keys.Enter)
            {
                //Enter
                Img.Dispose();
                Img = null;
                Img = cbzLib.NextPicture();
                resetScrollbars();
            }
            else
            {
                NewPosition(lX, lY);
            }


        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            //vsb1.Left = this.Width - vsb1.Width - 1;
            //vsb1.Height = this.Height - 1;
            //hsb1.Top = this.Height - 16;
            //hsb1.Width = vsb1.Left - 2;
            //Panel1.Left = 0;
            //Panel1.Top = 0;
            //Panel1.Width = vsb1.Left - 2;
            //Panel1.Height = hsb1.Top - 2;
            //vsb1.Left = this.Width - vsb1.Width;
            //vsb1.Top = 0;
            //vsb1.Height = hsb1.Top;

            hsb1.Top = this.Height - hsb1.Height;
            hsb1.Left = 0;
            hsb1.Width = vsb1.Left;

            Panel1.Top = 0;
            Panel1.Left = 0;
            Panel1.Width = vsb1.Left;
            Panel1.Height = hsb1.Top;
 
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

    }
}