using System.Collections;
using System.Drawing;
using PocketNetCBZ.ZipAdapterSharpZip;


public class NetCFCBZLib
{

    protected string CBZFileName;
    protected ZipFile _ZipFile; // C1Zip.C1_ZipFile
    protected ArrayList _ZipFileEntries;
    public NetCFCBZLib(string fileName)
    {
        CBZFileName = fileName;
        LoadFileInfo();
    }

    protected void LoadFileInfo()
    {

        _ZipFile = new ZipFile(); 
        _ZipFile.Open(CBZFileName);
        mPageCount = 0;
        _ZipFileEntries = new ArrayList();
        foreach (ZipFileEntry x in _ZipFile.Entries())
        {
            string[] __filenameInfo = x.FileName.Split('.');
            if (__filenameInfo.Length > 1 && ("gif jpg").IndexOf(__filenameInfo[__filenameInfo.Length - 1].ToLower()) > -1)
            {
                mPageCount += 1;
                _ZipFileEntries.Add(x);
            }
        }
        _ZipFile.Close();
        //_ZipFile.Dispose()
        //_ZipFile = Nothing
    }

    protected int mPageCount = 0;
    public int pageCount
    {
        get
        {
            return mPageCount;
        }
    }

    protected int mPage = 1;
    public int Page
    {
        get
        {
            return mPage;
        }
        set
        {
            if (value > 0)
            {
                mPage = value;
            }
        }
    }


    public System.Drawing.Bitmap currentPicture(int width)
    {
        return currentPicture(width, 0);
    }

    public System.Drawing.Bitmap currentPicture()
    {
        return currentPicture(0, 0);
    }

    //INSTANT C# NOTE: C# does not support optional parameters. Overloaded method(s) are created above.
    //ORIGINAL LINE: Public Function currentPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
    public System.Drawing.Bitmap currentPicture(int width, int height)
    {
        return getPicture(width, height);
    }


    public System.Drawing.Bitmap NextPicture(int width)
    {
        return NextPicture(width, 0);
    }

    public System.Drawing.Bitmap NextPicture()
    {
        return NextPicture(0, 0);
    }

    //INSTANT C# NOTE: C# does not support optional parameters. Overloaded method(s) are created above.
    //ORIGINAL LINE: Public Function NextPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
    public System.Drawing.Bitmap NextPicture(int width, int height)
    {
        if (mPage == mPageCount)
        {
            mPage = 0;
        }
        mPage += 1;
        return getPicture(width, height);
    }


    public System.Drawing.Bitmap PrevPicture(int width)
    {
        return PrevPicture(width, 0);
    }

    public System.Drawing.Bitmap PrevPicture()
    {
        return PrevPicture(0, 0);
    }

    //INSTANT C# NOTE: C# does not support optional parameters. Overloaded method(s) are created above.
    //ORIGINAL LINE: Public Function PrevPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
    public System.Drawing.Bitmap PrevPicture(int width, int height)
    {
        if (mPage == 1)
        {
            mPage = mPageCount + 1;
        }
        mPage = mPage - 1;
        return getPicture(width, height);

    }

    protected System.Drawing.Bitmap getPicture(int width)
    {
        return getPicture(width, 0);
    }

    protected System.Drawing.Bitmap getPicture()
    {
        return getPicture(0, 0);
    }

    //INSTANT C# NOTE: C# does not support optional parameters. Overloaded method(s) are created above.
    //ORIGINAL LINE: Protected Function getPicture(Optional ByVal width As Integer = 0, Optional ByVal height As Integer = 0) As System.Drawing.Bitmap
    protected System.Drawing.Bitmap getPicture(int width, int height)
    {
        _ZipFile.Open(CBZFileName);
        System.IO.MemoryStream mStream = _ZipFile.Entries()[mPage - 1].OpenReader(); //__ZipFile.GetInputStream(DirectCast(__ZipFileEntries(_page - 1), Zip.ZipEntry))

        System.Drawing.Bitmap mImg = new System.Drawing.Bitmap(mStream);

        mStream = null;
        _ZipFile.Close();
        return mImg;

    }

}
