namespace PocketNetCBZ.ZipAdapterSharpZip
{

    public class ZipFile
    {

        private ICSharpCode.SharpZipLib.Zip.ZipFile _ZipFile;
        private System.Collections.ObjectModel.Collection<ZipFileEntry> _Entries;
        public ZipFile()
        {
            _Entries = null;
        }

        public void Open(string fn)
        {
            _ZipFile = new ICSharpCode.SharpZipLib.Zip.ZipFile(fn);
        }

        public System.Collections.ObjectModel.Collection<ZipFileEntry> Entries()
        {
            if (_Entries != null)
            {
                return _Entries;
            }

            System.Collections.ObjectModel.Collection<ZipFileEntry> _Rtn = new System.Collections.ObjectModel.Collection<ZipFileEntry>();

            foreach (ICSharpCode.SharpZipLib.Zip.ZipEntry _ze in _ZipFile)
            {
                ZipFileEntry ZipFe = new ZipFileEntry();
                ZipFe.FileName = _ze.Name;
                ZipFe.Index = _ze.ZipFileIndex;
                ZipFe.Parent = this;
                _Rtn.Add(ZipFe);
            }
            return _Rtn;
        }

        public System.IO.MemoryStream GetReader(ZipFileEntry ZipFe)
        {

            System.IO.MemoryStream _MemStream = new System.IO.MemoryStream();
            ICSharpCode.SharpZipLib.Zip.ZipEntry _ZipEntry = _ZipFile.GetEntry(ZipFe.FileName);

            System.IO.Stream _ZipStream = _ZipFile.GetInputStream(_ZipEntry);
            int _BufferSize = int.MaxValue;
            if (_ZipStream.Length < System.Convert.ToInt64(_BufferSize))
            {
                _BufferSize = System.Convert.ToInt32(_ZipStream.Length);
            }
            byte[] buffer = new byte[_BufferSize + 1];
            int Size = 0;
            do
            {
                Size = _ZipStream.Read(buffer, 0, buffer.Length);
                _MemStream.Write(buffer, 0, Size);
            } while (!(Size <= 0));
            _ZipStream.Close();
            return _MemStream;
        }

        public void Close()
        {
            _ZipFile.Close();
        }

        public void Dispose()
        {
            _ZipFile = null;
            _Entries = null;
        }

    }

    public class ZipFileEntry
    {
        private ZipFile _Parent;
        private string _FileName;
        private int _Index = 0;

        public ZipFile Parent
        {
            get
            {
                return _Parent;
            }
            set
            {
                _Parent = value;
            }
        }

        public string FileName
        {
            get
            {
                return _FileName;
            }
            set
            {
                _FileName = value;
            }
        }

        public int Index
        {
            get
            {
                return _Index;
            }
            set
            {
                _Index = value;
            }
        }

        public System.IO.MemoryStream OpenReader()
        {
            return _Parent.GetReader(this);
        }

    }

}
